/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

const LEVELS = [
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0133000000000000000000112',
        code: 'WIEDERHOLE 5 MAL\n    plus\nplus',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Es gibt eine Wiederholung mit fester Anzahl 5: Jedesmal wird ein Plättchen gelegt. Nach der Wiederholung mit fester Anzahl wird noch ein weiteres Plättchen gelegt, insgesamt also 1 × 5 + 1 = 6.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 6 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0133000000000000000000112',
        code: 'WIEDERHOLE 2 MAL\n    WIEDERHOLE 3 MAL\n        plus\nplus',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Es gibt eine Wiederholung mit fester Anzahl 2, die eine Wiederholung mit fester Anzahl 3 beinhaltet, welche wiederum eine Sequenz mit einmal <code>plus</code> enthält. Nach den Wiederholungen steht noch einmal <code>plus</code>. Insgesamt wird <code>plus</code> somit 2 × 3 × 1 + 1 = 7 mal ausgeführt.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 7 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0133000000000000000000112',
        code: 'WIEDERHOLE 4 MAL\n    WIEDERHOLE 2 MAL\n        plus\n    linksrum\n    plus',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Es gibt eine Wiederholung mit fester Anzahl 4, die eine Wiederholung mit fester Anzahl 2 und zusätzlich noch einmal <code>plus</code> beinhaltet. Die zweifach zu wiederholende Sequenz enthält ein <code>plus</code>. Insgesamt wird <code>plus</code> somit 4 × (2 × 1 + 1) = 12 mal ausgeführt.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 12 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0133000000000000000000112',
        code: 'WIEDERHOLE 3 MAL\n    WIEDERHOLE 2 MAL\n        plus\n        linksrum\n        plus\n    plus',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Es gibt eine Wiederholung mit fester Anzahl 3, die eine Wiederholung mit fester Anzahl 2 und zusätzlich noch einmal <code>plus</code> beinhaltet. Die zweifach zu wiederholende Sequenz enthält zweifach <code>plus</code>. Insgesamt wird <code>plus</code> somit 3 × (2 × 2 + 1) = 15 mal ausgeführt.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 15 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0133000000000000000000112',
        code: 'WIEDERHOLE 2 MAL\n    WIEDERHOLE 2 MAL\n        plus\n        WIEDERHOLE 2 MAL\n            plus\n    plus',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Die Einrückungen bestimmt die Zugehörigkeit zu den einzelnen Wiederholungen mit fester Anzahl: Insgesamt wird <code>plus</code> 2 × [2 × (1 + 2 × 1) + 1] = 14 mal ausgeführt.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 14 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    }
];

window.roboterCodingTask = {
    levels: LEVELS
};
})(window);
